# ZI-INSTALLER

ZI-Installer został stworzony z myślą o prostej, szybkiej, kompaktowej instalacji zimletów.

## Schemat działania

Instalator składa się z dwóch głównych części:

- ```ZI-Installer```
- ```ZI-LicenseManager```

## Flow instalacji modułu

Proces instalacji składa się z 2 części:

1. Przerzucenie wszystkich wymaganych plików do katalogu modułu, provisioning bazy danych (```ZI-Installer```)
    1. Inicjalizacja wszystkich opcji, zarówno argumentów opcjonalnych jak i tych zlokalizowanych w
       pliku ```zi-install-conf.json``` do struktury ```%opts``` [```SetOpts()```, ```VerifyParams()```]
    2. Przekopiowanie plików instalacyjnych do katalogu roboczego ```/tmp```
    3. Print konfiguracji instalacyjnej [```PrintConf()```]
    4. Utworzenie bazy danych i jej konfiguracja (konfiguracja pobierana z ```zi-install-conf.json```)
    5. Utworzenie docelowego katalogu zimletu (
       default: ```/opt/zimbra/lib/ext/{ZIMLET_NAME}```) [```CreateZimletDirectory()```]
    6. Usunięcie poprzednich wersji Zimletu
    7. Skopiowanie plików zimletu
    8. Skopiowanie plików ```helpers/``` [```CopyHelpersFiles()```]
    9. Skopiowanie customowych skryptów
    10. Deploy zimletów [```DeployZimlets()```]
    11. Uruchomienie skryptu ```ZI-LicenseManager``` bądź zakończenie procesu instalacji
2. Aktywacja licencji (```ZI-LicenseManager```):
    1. Ustawienie hasła
    2. Pobranie licencji [```GetLicenses()```]
    3. Wybranie licencji, pobranie rozszerzeń do niej przypisanych [```GetExtensions()```]
    4. Pobranie licencji [```DownloadLicense()```]
    5. Zapisanie licencji [```SaveLicense()```]
    6. Aktywacja licencji [```ActivateLicense()```]
    7. Aktywacja rozserzeń [```ActivateExtensions()```]
    8. Usunięcie cache'a [```DeleteCache()```]

### ```zi-install-conf.json```

Konfiguracji tego pliku towarzyszy konfiguracja *helpersów* w roocie konfiguracji należy uwzględnić poniższą
konfigurację:

```json
"files": [
   {
     "src": "helpers/language.properties",
     "dest": "$HOME/lib/ext/IntalioZiPiler/language.properties",
     "overwrite": false
   },
   {
     "src": "helpers/language.properties",
     "dest": "$HOME/lib/ext/IntalioZiPiler/language.properties",
     "overwrite": true
   }
]
```
Możliwe jest uwzględnienie zmiennych środowiskowych zawartych w ścieżce ```dest```
**Uwaga**: zmienne pobierane są przypisane użytkownikowi *zimbra*.


